<template>
  <div class="product-insights-properties-content">
    <div class="product-insights-row has-cols in-half">
      <div class="product-insights-col"><div class="product-insights-label">{{ $t('Property') }}</div></div>
      <div class="product-insights-col"><div class="product-insights-label">{{ $t('Values') }}</div></div>
    </div>
    <div v-for="(group, key, index) in sortedGroupProperties"
         :key="'product-insights-property-group-'+ index"
         class="product-insights-row has-cols in-half">
      <div class="product-insights-col insights-group-name">
        <div class="product-insights-value">{{ key }}</div>
      </div>
      <div class="product-insights-col insights-properties">
        <div v-for="(property, index) in group"
             :key="'product-insights-property-'+ index"
             :title="getTranslatedProperty(property, 'name')"
             class="product-insights-value"
             :class="property.isActive ? 'is-active' : ''"
             @click="togglePropertyFilter(property)">
          {{ getTranslatedProperty(property, 'name') }}
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
  import { onMounted } from "@vue/composition-api";
  import { useProductInsights } from "../../../logic/composables/widgets/useProductInsights";
  import { getTranslatedProperty } from "@shopware-pwa/helpers";

  export default {
  name: "InsightsProperties",
  components: {},
  props: {
    product: {
      type: [Object,Array,String],
      default: null,
    },
  },
  setup(props, {}) {
    const {
      getSortedGroupProperties,
      togglePropertyFilter,
      sortedGroupProperties
    } = useProductInsights(props.product);

    onMounted(async () => {
      await getSortedGroupProperties();
    })

    return {
      sortedGroupProperties,
      togglePropertyFilter,
      getTranslatedProperty
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .product-insights-properties-content {
    .product-insights-row {
      margin-bottom: 5px;
    }

    .product-insights-label {
      font-weight: 500;
    }

    .product-insights-value {
      color: var(--c-text) !important;
    }

    .insights-properties {
      display: flex;
      flex-wrap: wrap;

      .product-insights-value {
        border-radius: 8px;
        background-color: var(--c-light);
        padding: 2px 5px !important;
        margin-right: 5px;
        margin-bottom: 5px;

        &:hover {
          cursor: pointer;
        }

        &.is-active {
          background-color: var(--_c-gray-accent);
        }
      }
    }

    ::v-deep .sf-accordion-item__content {
      padding-bottom: 20px;
    }
  }
</style>
